<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * $Revision: 116 $
 * $Author: PragmaMx $
 * $Date: 2021-04-23 19:24:31 +0200 (Fr, 23. Apr 2021) $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radmincontent')) {
    mxErrorScreen('Access Denied');
    die();
}

$wysiwyg = 1;
$wysiwyg_content = 1;

global $module_name, $prefix;


$module_name = basename(dirname(__dir__));

//include_once(PMX_MODULES_DIR . DS . $module_name . DS . "setup.pmx.php");
include_once(PMX_MODULES_DIR . DS . $module_name . DS . "includes" . DS . "functions.php");
//include_once(PMX_MODULES_DIR . DS . $module_name . DS . "includes" . DS . "functions-old.php");
//mxGetLangfile($module_name);

if (!isset($act)) $act="";

if (empty($ok)) $ok = 0;

switch ($act)
{
	case "activate":
		mxSetModuleActive($module_name,1);
	break;
}

imp_main();

function imp_main()
{
    global  $module_name, $currentlang, $credits;

	$conf = load_class('Book', $module_name);
	$credits=mxcredit_shortinfo_string(PMX_MODULES_DIR . DS . $module_name . DS . "setup.pmx.php");
    $info =  _LEGAL;

    switch (pmxAdminForm::CheckButton()) {
        case "save":
		case "accept":
            $root['text1'] = "";
            $text = array();
            foreach ($_POST["textlegal"] as $key => $value) {
                $text[$key] = mxAddSlashesForSQL($value);
            }
            $root['text1'] = addslashes(serialize($text));
            $root['text2'] = "";
            $text = array();
            foreach ($_POST["textpriv"] as $key => $value) {
                $text[$key] = mxAddSlashesForSQL($value);
            }
            $root['text2'] = addslashes(serialize($text));			
			$conf->setRootRecord($root);
			mxRedirect("admin.php?op=$module_name", _CHANGESAREOK, 1);
            break;
        default:
            break;
    }
	$error = (!mxModuleActive($module_name))?"<div class=\"error\">" . _MODULENOTACTIVE . " <a href=\"admin.php?op=".$module_name."&amp;act=activate\" class=\"button\" >"._ACTIVATE."</a></div>":"";

    $tb = load_class('AdminForm', "legal");
    $tb->__set('target_url', "admin.php?op=" . $module_name . "");
    $tb->__set("tb_text", "");
    $tb->__set("tb_direction", 'right');
    $tb->__set("infobutton", false);
    $tb->__set("tb_pic_heigth", 25);
    $tb->__set("csstoolbar", "toolbar1");
    $tb->__set('buttontext', false);
    $tb->__set('homelink', false);
    $tb->__set('fieldhomebutton', true);
    $tb->addToolbar("save");

    $tb->addFieldset("language", $info, "", false);

    pmxHeader::add_tabs(true);

    $tabsscript = '<script type="text/javascript">/* <![CDATA[ */
          $(document).ready(function()
            {
                $(\'ul.tabs-nav\').each(function(){

                // Fuer jeden Satz Tabs wollen wir verfolgen welcher
                // Tab aktiv ist und der ihm zugeordnete Inhalt
                var $active, $content, $links = $(this).find(\'a\');

                // Der erste Link ist der zu Anfang akitve Tab
                $active = $links.first().addClass(\'active\');
                $content = $($active.attr(\'href\'));

                // Verstecke den restlichen Inhalt
                $links.not(\':first\').each(function () {
                    $($(this).attr(\'href\')).hide();
                });

                // Binde den click event handler ein
                $(this).on(\'click\', \'a\', function(e){

                    // Mache den alten Tab inaktiv
                    $active.removeClass(\'active\');
                    $content.hide();

                    // Aktualisiere die Variablen mit dem neuen Link und Inhalt
                    $active = $(this);
                    $content = $($(this).attr(\'href\'));

                    // Setze den Tab aktiv
                    $active.addClass(\'active\');
                    $content.show();

                    // Verhindere die Anker standard click Aktion
                    e.preventDefault();
                });
            });
         });
        /* ]]> */</script>';

    $langlist = mxGetAvailableLanguages(true);

    $root = $conf->getRootRecord();
    $text1 = array();
	if (!trim($root['text1'])=="") {
	    $text1 = unserialize($root['text1']);
	}
    $text2 = array();
	if (!trim($root['text2'])=="") {
	    $text2 = unserialize($root['text2']);
	}	
    /* tabs generieren */
    $tb->add("language", "html", "<ul class='tabs-nav' >");
    foreach ((array)$langlist as $caption => $value) {
        $img = mxCreateImage("images/language/flag-" . $value . ".png");
        $tb->add("language", "html", "<li class='tabs-nav'><a href='#tab-" . $value . "' class='item'>" . $img . " " . $caption . "</a></li>");
    }
    $tb->add("language", "html", "</ul>");
    $tb->add("language", "html", "<div class='tabs-panel' >");
    $tb->add("language", "html", "<div>");
    foreach ((array)$langlist as $caption => $value) {
		$text = (array_key_exists($value,$text1))?$text1[$value]:"";
        $text = stripslashes($text);
        $text = "".$text."";
		$priv = (array_key_exists($value,$text2))?$text2[$value]:"";
        $priv = stripslashes($priv);
        $priv = "".$priv."";		
        $tb->add("language", "html", "<div id='tab-" . $value . "'>");
        $tb->add("language", "output", "<h4>" . $caption . "</h4>");
		//$tb->add("language", "html", $text);
        $tb->add("language", "editor", "textlegal[" . $value . "]", $text, _LEGAL, "", 400);
        $tb->add("language", "editor", "textpriv[" . $value . "]", $priv, _LEGALPP, "", 400);
        $tb->add("language", "html", "</div><div class=\"clear\"></div>");
    }
    $tb->add("language", "html", "</div>");
    $tb->add("language", "html", "</div>");
    $tb->add("language", "html", $tabsscript);
	
	
    /* formular abrufen */
    $form = $tb->Show();
    /*
     * Template
     */
    // Template initialisieren
    $template = load_class('Template');
    $template->init_path(__FILE__);

    /* hier die Ausgabefelder angeben */

    /* Variablen an das Template uebergeben */
    $template->assign(compact('form', 'info', 'module_name','error','credits'));

    include('header.php');
    /* Template ausgeben (echo) */
    $template->display('admin.config.html');

    include('footer.php');
}


?>